"use strict";
exports.__esModule = true;
exports.formatText = void 0;
var react_1 = require("react");
var react_native_1 = require("react-native");
var formaters_1 = require("./formaters");
var createStyledElement = function (_a) {
    var text = _a.text, styles = _a.styles, jsxElement = _a.jsxElement, props = _a.props;
    return (<>
    {jsxElement}
    <react_native_1.Text {...props} style={[props.style, styles]}>
      {text}
    </react_native_1.Text>
  </>);
};
var formatText = function (props, regex) {
    var children = props.children, highlightedTextStyles = props.highlightedTextStyles;
    var TEXT_WITH_BRACKETS = regex.TEXT_WITH_BRACKETS, TEXT_AMONG_BRACKETS = regex.TEXT_AMONG_BRACKETS;
    var allText = Array.isArray(children) ? children.join() : children;
    var formater = formaters_1["default"]
        .map(function (Formater) { return new Formater(highlightedTextStyles, regex); })
        .find(function (Formater) { return Formater.validate(allText); });
    if (!formater)
        return <>{allText}</>;
    var textArray = allText.split(TEXT_WITH_BRACKETS);
    var finalTextElement = textArray.reduce(function (jsxElement, partialText) {
        if (TEXT_AMONG_BRACKETS.test(partialText)) {
            var _a = formater.create(partialText), text = _a.text, styles = _a.styles;
            return createStyledElement({ text: text, styles: styles, jsxElement: jsxElement, props: props });
        }
        return createStyledElement({ text: partialText, jsxElement: jsxElement, props: props });
    }, <></>);
    return <>{finalTextElement}</>;
};
exports.formatText = formatText;
