"use strict";
exports.__esModule = true;
exports.NamedStyles = void 0;
var NamedStyles = /** @class */ (function () {
    function NamedStyles(styles, regex) {
        this.styles = styles;
        this.regex = regex;
    }
    NamedStyles.prototype.validate = function (text) {
        var stylesIsObject = typeof this.styles === 'object' && !Array.isArray(this.styles);
        if (!stylesIsObject)
            return false;
        var _a = this.regex, TEXT_AMONG_BRACKETS = _a.TEXT_AMONG_BRACKETS, TEXT_WITH_BRACKETS = _a.TEXT_WITH_BRACKETS, KEY_VALUE_TEXT = _a.KEY_VALUE_TEXT;
        var textIsHighlighted = TEXT_WITH_BRACKETS.test(text);
        if (!textIsHighlighted)
            return false;
        var textIsKeyValue = text.split(TEXT_AMONG_BRACKETS).some(function (t) {
            var textIsKeyValueText = KEY_VALUE_TEXT.test(t);
            return textIsKeyValueText;
        });
        return textIsKeyValue;
    };
    NamedStyles.prototype.create = function (text) {
        var _this = this;
        var TEXT_AMONG_BRACKETS = this.regex.TEXT_AMONG_BRACKETS;
        var pureText = text.replace(TEXT_AMONG_BRACKETS, '$1');
        var keysAndText = pureText.split('=');
        var keys = keysAndText[0].split(',');
        var styles = keys.map(function (key) { return _this.styles[key]; });
        var finalText = keysAndText[1];
        return {
            text: finalText,
            styles: styles
        };
    };
    return NamedStyles;
}());
exports.NamedStyles = NamedStyles;
