"use strict";
exports.__esModule = true;
exports.NormalStyles = void 0;
var NormalStyles = /** @class */ (function () {
    function NormalStyles(styles, regex) {
        this.styles = styles;
        this.regex = regex;
        this.currentStyle = 0;
    }
    NormalStyles.prototype.validate = function (text) {
        var stylesIsArray = Array.isArray(this.styles);
        if (!stylesIsArray)
            return false;
        var _a = this.regex, TEXT_AMONG_BRACKETS = _a.TEXT_AMONG_BRACKETS, TEXT_WITH_BRACKETS = _a.TEXT_WITH_BRACKETS, KEY_VALUE_NUMBER = _a.KEY_VALUE_NUMBER, KEY_VALUE_TEXT = _a.KEY_VALUE_TEXT;
        var textIsHighlighted = TEXT_WITH_BRACKETS.test(text);
        if (!textIsHighlighted)
            return false;
        var textIsKeyValue = text.split(TEXT_AMONG_BRACKETS).some(function (t) {
            var textIsKeyValueNumber = KEY_VALUE_NUMBER.test(t);
            if (textIsKeyValueNumber)
                return true;
            var textIsKeyValueText = KEY_VALUE_TEXT.test(t);
            if (textIsKeyValueText)
                return true;
            return false;
        });
        return !textIsKeyValue;
    };
    NormalStyles.prototype.create = function (text) {
        var TEXT_AMONG_BRACKETS = this.regex.TEXT_AMONG_BRACKETS;
        var pureText = text.replace(TEXT_AMONG_BRACKETS, '$1');
        var style = this.getStyle();
        return {
            text: pureText,
            styles: style
        };
    };
    NormalStyles.prototype.getStyle = function () {
        if (this.currentStyle < this.styles.length) {
            var style = this.styles[this.currentStyle];
            this.currentStyle++;
            return style;
        }
    };
    return NormalStyles;
}());
exports.NormalStyles = NormalStyles;
