"use strict";
exports.__esModule = true;
exports.NumberedStyles = void 0;
var NumberedStyles = /** @class */ (function () {
    function NumberedStyles(styles, regex) {
        this.styles = styles;
        this.regex = regex;
    }
    NumberedStyles.prototype.validate = function (text) {
        var stylesIsArray = Array.isArray(this.styles);
        if (!stylesIsArray)
            return false;
        var _a = this.regex, TEXT_AMONG_BRACKETS = _a.TEXT_AMONG_BRACKETS, TEXT_WITH_BRACKETS = _a.TEXT_WITH_BRACKETS, KEY_VALUE_NUMBER = _a.KEY_VALUE_NUMBER;
        var textIsHighlighted = TEXT_WITH_BRACKETS.test(text);
        if (!textIsHighlighted)
            return false;
        var textIsKeyValue = text.split(TEXT_AMONG_BRACKETS).some(function (t) {
            var textIsKeyValueNumber = KEY_VALUE_NUMBER.test(t);
            return textIsKeyValueNumber;
        });
        return textIsKeyValue;
    };
    NumberedStyles.prototype.create = function (text) {
        var _this = this;
        var TEXT_AMONG_BRACKETS = this.regex.TEXT_AMONG_BRACKETS;
        var pureText = text.replace(TEXT_AMONG_BRACKETS, '$1');
        var keysAndText = pureText.split('=');
        var keys = keysAndText[0]
            .split(',')
            .map(function (stringNumbers) { return parseInt(stringNumbers) - 1; });
        var styles = keys.map(function (key) { return _this.styles[key]; });
        var finalText = keysAndText[1];
        return {
            text: finalText,
            styles: styles
        };
    };
    return NumberedStyles;
}());
exports.NumberedStyles = NumberedStyles;
